/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "Wave Demo"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "Wave Demo"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "1"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  char * params_id_arg;	/**< @brief string identifying the main parameters, e.g. 128, 128p, ....  */
  char * params_id_orig;	/**< @brief string identifying the main parameters, e.g. 128, 128p, ... original value given at command line.  */
  const char *params_id_help; /**< @brief string identifying the main parameters, e.g. 128, 128p, ... help description.  */
  int print_params_flag;	/**< @brief show the parameters and exit (default=off).  */
  const char *print_params_help; /**< @brief show the parameters and exit help description.  */
  long key_arg;	/**< @brief key identifier, used to seed the PRNG (default='0').  */
  char * key_orig;	/**< @brief key identifier, used to seed the PRNG original value given at command line.  */
  const char *key_help; /**< @brief key identifier, used to seed the PRNG help description.  */
  long message_arg;	/**< @brief message identifier, used to seed the PRNG (default='0').  */
  char * message_orig;	/**< @brief message identifier, used to seed the PRNG original value given at command line.  */
  const char *message_help; /**< @brief message identifier, used to seed the PRNG help description.  */
  int number_arg;	/**< @brief number of signatures to produce (default='1').  */
  char * number_orig;	/**< @brief number of signatures to produce original value given at command line.  */
  const char *number_help; /**< @brief number of signatures to produce help description.  */
  int verbose_arg;	/**< @brief verbose level, 0 is quiet, 1 is minimal (default='1').  */
  char * verbose_orig;	/**< @brief verbose level, 0 is quiet, 1 is minimal original value given at command line.  */
  const char *verbose_help; /**< @brief verbose level, 0 is quiet, 1 is minimal help description.  */
  char * filename_arg;	/**< @brief input filename.  */
  char * filename_orig;	/**< @brief input filename original value given at command line.  */
  const char *filename_help; /**< @brief input filename help description.  */
  int check_flag;	/**< @brief check the signatures produced (default=off).  */
  const char *check_help; /**< @brief check the signatures produced help description.  */
  int stat_flag;	/**< @brief give statistics on rejection rates (default=off).  */
  const char *stat_help; /**< @brief give statistics on rejection rates help description.  */
  int no_save_flag;	/**< @brief do not save the signatures (default=off).  */
  const char *no_save_help; /**< @brief do not save the signatures help description.  */
  int log_flag;	/**< @brief make a log file (default=off).  */
  const char *log_help; /**< @brief make a log file help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int params_id_given ;	/**< @brief Whether params_id was given.  */
  unsigned int print_params_given ;	/**< @brief Whether print_params was given.  */
  unsigned int key_given ;	/**< @brief Whether key was given.  */
  unsigned int message_given ;	/**< @brief Whether message was given.  */
  unsigned int number_given ;	/**< @brief Whether number was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int filename_given ;	/**< @brief Whether filename was given.  */
  unsigned int check_given ;	/**< @brief Whether check was given.  */
  unsigned int stat_given ;	/**< @brief Whether stat was given.  */
  unsigned int no_save_given ;	/**< @brief Whether no_save was given.  */
  unsigned int log_given ;	/**< @brief Whether log was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
